/*
 *  Copyright (C) Samuel Thibault <samuel.thibault@fnac.net>
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation ; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY ; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the program ; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*
 * codes.h
 *
 * a ppp analyser for Unix
 *
 * (c) Copyright 2000-2001 Samuel Thibault
 */

// PPP stuff
#define PPP_FLAG	0x7e
#define PPP_ESCAPE	0x7d
#define START_CHAR	0x11
#define STOP_CHAR	0x13
#define PPPINITFCS      0xffff  /* Initial FCS value */
#define PPPGOODFCS      0xf0b8  /* Good final FCS value */

// PPP states
#define SPPP_ADDRESS	0
#define SPPP_CONTROL 	1
#define SPPP_PROTOCOL 	2
#define SPPP_CP		3
#define SPPP_IP		4
#define SPPP_CHAP	5
#define SPPP_PAP	6

// CP constants
#define LCP	0
#define IPCP	1

// CP states
#define SCP_CODE	0
#define SCP_IDENTIFIER	1
#define SCP_LENGTHHI	2
#define SCP_LENGTHLO	3
#define SCP_OPTIONS 	4
#define SCP_TXT		5
#define SCP_MAGIC	6

// CP Options states
#define SOCP_TYPE	0
#define SOCP_LENGTH	1
#define SOCP_DATA	2

// CP Options contents
#define COCP_NUMINT	0
#define COCP_BININT	1
#define COCP_ADRIP	2
#define COCP_AUTHOPT	3
#define COCP_QUALOPT	4
#define	COCP_COMPR	5
#define COCP_FCSALT	6
#define COCP_SDP	7

// IP protocols
#define ICMP	1
#define TCP	6
#define UDP	17

// TCP bits
#define TCP_URG	5
#define TCP_ACK 4
#define TCP_PSH 3
#define TCP_RST 2
#define TCP_SYN 1
#define TCP_FIN 0

// AUTH states
#define SAUTH_CODE		0
#define SAUTH_IDENTIFIER	1
#define SAUTH_LENGTHHI		2
#define SAUTH_LENGTHLO		3
#define SAUTH_LENTXT		4
#define SAUTH_TXT		5
#define SAUTH_CHALRESP		6

// PAP states
#define SPAP_LEN	0
#define SPAP_TXT	1

// CHAP states
#define SCHAP_VSIZE	0
#define SCHAP_VALUE	1
#define SCHAP_NAME	2

// used everywhere
#define discard 	127
