/*
 *  Copyright (C) Samuel Thibault <samuel.thibault@fnac.net>
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation ; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY ; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the program ; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*
 * tcp.c
 *
 * a ppp analyser for Unix
 *
 * (c) Copyright 2000-2001 Samuel Thibault
 */

#include <stdio.h>
#include "analyse.h"
#include "codes.h"

#define TCPloggue(s)	if (show.tcp) loggue(s);

extern short protopointeur;

void analysetcp(unsigned char c) {
	static char s[64];
	static short lgent;
//	static unsigned int size;
	static unsigned int integer;

	switch(protopointeur) {
/* port : source then desti */
	case 0:
	case 2:
	case 14:
		integer=c;
		break;
	case 1:
		TCPloggue(" ");
		TCPloggue(findservice((integer << 8) + c));
		TCPloggue(" > ");
		integer=0;
		break;
	case 3:
		TCPloggue(findservice((integer << 8) + c));
		integer=0;
		break;
/* sequence number then ack number */
	case 4:
	case 5:
	case 6:
	case 8:
	case 9:
	case 10:
		integer=(integer << 8) + c;
		break;
	case 7:
		sprintf(s," s%u",(integer << 8) + c);
		TCPloggue(s);
		integer=0;
		break;
	case 11:
		sprintf(s," a%u",(integer << 8) + c);
		TCPloggue(s);
		integer=0;
		break;
/* lg_ent */
	case 12:
		lgent=(c && 0xf0)>>4;
		break;
/* bits */
	case 13:
#define logguebit(bit,log)	TCPloggue(c & (1 << bit) ? log : "");
		TCPloggue(" ");
		logguebit(TCP_URG,"U");
		logguebit(TCP_PSH,"P");
		logguebit(TCP_SYN,"S");
		logguebit(TCP_RST,"R");
		logguebit(TCP_ACK,"A");
		logguebit(TCP_FIN,"F");
		break;
/* window */
/*	case 14:
 *		integer=c;
 *		break;
 */
	case 15:
		sprintf(s," win %u",(integer << 8) + c);
		TCPloggue(s);
		break;
/* checksum & urgent pointer */
	case 16:
	case 17:
	case 18:
	case 19:
		break;
	}
	protopointeur++;
}
