/*
 *  Copyright (C) Samuel Thibault <samuel.thibault@fnac.net>
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation ; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY ; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the program ; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*
 * udp.c
 *
 * a ppp analyser for Unix
 *
 * (c) Copyright 2000-2001 Samuel Thibault
 */

#include <stdio.h>
#include "analyse.h"
#include "codes.h"

#define UDPloggue(s)	if (show.udp) loggue(s);

#define DOMAIN	53

extern short protopointeur;
extern short applipointeur;

void analyseudp(unsigned char c) {
	static char s[64];
	static unsigned short w16;
	static unsigned short source,desti;
	switch(protopointeur) {
	/* beginning, and source port */
	case 0:
		applipointeur=0;
	case 2:
	case 4:
	case 6:
		w16=c;
		break;
	/* source port */
	case 1:
		source=(w16<<8)|c;
		sprintf(s," %u",source);
		UDPloggue(s);
		break;
	/* desti port */
	case 3:
		desti=(w16<<8)|c;
		sprintf(s,"->%u",desti);
		UDPloggue(s);
		break;
	/* size */
	case 5:
		w16=(w16<<8)|c;
		sprintf(s,"(%u)",w16);
		UDPloggue(s);
		break;
	/* checksum */
	case 7:
		w16=(w16<<8)|c;
		if (w16) UDPloggue("ck");
		break;
	default:
		if ((source==DOMAIN) || (desti==DOMAIN)) analysedomain(c);
	}
	protopointeur++;
}
